
/*
         * BOOL GetSerialNumber(TCHAR*, DWORD, DWORD);
         * pSerialNumber        Pointer of a array that declare by upper layer application.
         *                      The defined array contains 8 elements when Index = 0.
         *                      The defined array contains 10 elements when Index = 1.
         * OutputBufferSize     Size of pSerialNumber array.
         *                      Must be 8 when Index = 0.
         *                      Must be 10 when Index = 1.
         * Index                Zero based index of the SerialNumber which should be returned.
         * 
*/

HINSTANCE g_hDllInstance = NULL;
typedef BOOL (CALLBACK* LPFNGetSerialNumber)(TCHAR*, DWORD, DWORD);
LPFNGetSerialNumber lpfnGetSerialNumber = NULL;

BOOL Start()
{
	g_hDllInstance = LoadLibrary(L"externapi.dll");
	
	if (g_hDllInstance)
	{
		lpfnGetSerialNumber = (LPFNGetSerialNumber)GetProcAddress(g_hDllInstance, L"GetSerialNumber");
				
		if (lpfnGetSerialNumber)
		{
			ReadSerialnumber1();
			ReadSerialnumber2();
		}
		else
			MessageBox(L"Loading function pointer failed!!", L"Error", MB_OK);
		
		FreeLibrary( g_hDllInstance );
	}
	else
		MessageBox(L"Loading externapi.dll failed!!", L"Error", MB_OK);
}

void ReadSerialnumber1()
{
	TCHAR sn[32] = {0,};
	BOOL success = FALSE;
	success = lpfnGetSerialNumber(sn, 8, 0);
	
	if (success)
	{
		CString msg;
		msg.Format(L"SYS Serial Number 1 : %s", sn);
		MessageBox(msg.GetBuffer(), L"Info", MB_OK);
	}
	else
		MessageBox(L"Not Available!", L"Error", MB_OK);
}

void ReadSerialnumber2()
{
	TCHAR sn[32] = {0,};
	BOOL success = FALSE;
	success = lpfnGetSerialNumber(sn, 10, 1);
	
	if (success)
	{
		CString msg;
		msg.Format(L"SYS Serial Number 2 : %s", sn);
		MessageBox(msg.GetBuffer(), L"Info", MB_OK);
	}
	else
		MessageBox(L"Not Available!", L"Error", MB_OK);
}