using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using OpenNETCF.Windows.Forms;
using OpenNETCF.Win32; 

namespace Hook
{
	public partial class Form1 : Form
	{
		private KeyboardHook m_keyHook;
				
		public Form1()
		{
			InitializeComponent();
								
			m_keyHook = new KeyboardHook(); 
			m_keyHook.KeyDetected += OnKeyDetected; 
			m_keyHook.PassOnKeys = false;
            m_keyHook.Enabled = true;
                        
            listView1.Font = new Font("Tahoma", 8, FontStyle.Regular); //diese Schriftart hat immer gleiche Breite
            btClearList_Click( null, EventArgs.Empty );
            
		}
		
		private void btClearList_Click( object sender, EventArgs e )
		{
			listView1.Clear();
            listView1.Columns.Add("KeyCode",70 * 2, HorizontalAlignment.Left);
			listView1.Columns.Add("ScanCode",70 * 2, HorizontalAlignment.Left);
			listView1.Columns.Add("KeyMessage",70 * 2, HorizontalAlignment.Left);
		}
		
		private void btClose_Click( object sender, EventArgs e )
		{
			m_keyHook.Dispose(); 
			m_keyHook = null;
			
			this.Close();
		}	
		
		void OnKeyDetected(OpenNETCF.Win32.WM keyMessage, KeyData keyData) 
        { 
            if (this.InvokeRequired) 
            { 
                this.Invoke(new KeyHookEventHandler(OnKeyDetected), new object[] { keyMessage, keyData }); 
                return; 
            } 
            
			//if( keyData.KeyCode == 97 )
			//    m_keyHook.PassOnKeys = true;
			//else
			//    m_keyHook.PassOnKeys = false;
			
			AddItem(  keyData.KeyCode.ToString(), keyData.ScanCode.ToString(), keyMessage.ToString() );
        }
        
        private void AddItem( string text1, string text2, string text3 )
		{
			ListViewItem lvitem;
			
			lvitem = new ListViewItem( text1 );
			lvitem.SubItems.Add( text2 );
			lvitem.SubItems.Add( text3 );
			listView1.Items.Add( lvitem );
		}
	}
}